// Aqsis
// Copyright (c) 1997 - 2001, Paul C. Gregory
//
// Contact: pgregory@aqsis.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.library;

import static net.cellcomputing.himawari.library.EqModeBlock.*;
import net.cellcomputing.himawari.accessory.STLVector;

/**
 * Define the context that exists between calls to RiWorldBegin/RiWorldEnd.<br>
 *  RiWorldBegin/RiWorldEndが呼びだされている間に存在する、コンテキストを定義する。
 * 
 * @author NTT DATA Corporation
 */
public strictfp class CqWorldModeBlock extends CqModeBlock
{
	
	/**
	 * コンストラクタ。　初期値の設定。
	 * @param pconParent	前のコンテキスト。
	 */
	public CqWorldModeBlock( final CqModeBlock pconParent )
	{
		super(pconParent, World);
	 
		// Create new Attributes as they must be pushed/popped by the state change.
	    // 状態の変化で変わるアトリビュートを新しく作成。
		m_pattrCurrent = new CqAttributes( pconParent.m_pattrCurrent );
	    m_pattrCurrent.AddRef();
	    m_ptransCurrent = new CqTransform( pconParent.m_ptransCurrent );
	}

	/** 
	 * デストラクタ。　<br>
	 * 参照の消去。　(参照カウンタをデクリメントする。)
	 * @see net.cellcomputing.himawari.library.CqModeBlock#destruct()
	 */
	@Override
	public void destruct()
	{
		m_pattrCurrent.Release();
	}


    /**
     * Create a main context.<br>
     * 	メインのコンテキストを作成。
     * 
     * @warning ワールドコンテキストの中で、このメソッドが呼ばれた場合エラーとなる。
     */
	@Override
    public CqModeBlock BeginMainModeBlock()
    {
        return  null;	// Error
    }	
    
    /** 
     * Create a frame context.<br>
     *　	フレームのコンテキストを作成。
     *
     * @warning ワールドコンテキストの中で、このメソッドが呼ばれた場合エラーとなる。
     */
	@Override
    public CqModeBlock BeginFrameModeBlock()
    {
        return  null;	// Error
    }	
	
    /** 
     * Create a world context.<br>
     * 	ワールドのコンテキストを作成。
     * 
     * @warning ワールドコンテキストの中で、このメソッドが呼ばれた場合エラーとなる。
     */
	@Override
    public CqModeBlock	BeginWorldModeBlock()
    {
        return 	null;	// Error
    }	

    /** 
     * Delete the world context.<br>
     * 	ワールドコンテキストを消去。
     * 
     * @attention このメソッドのみ、ワールドのコンテキストを消去することができる。
     */
	@Override
    public	void	EndWorldModeBlock()
    {
		destruct();
    }

    /** 
     * Get a reference to the options at the parent context, <br>
     * as world context doesn't store options.<br>
     *  親のコンテキストのオプションのゲッタ。<br>　
     *  (ワールドコンテキストはオプションが保存されない。)
     *  
     * @return 現在のオプション
     */
	@Override
    public	CqOptions	optCurrent()
    {
        return ( pconParent().optCurrent() );
    }
	
	
	/**
	 * Hold a reference to the specified lightsource in this context.<br>
     * 	このコンテキストで指定された光源の参照を持つ
     *
     * @param	pLS 光の情報
	 * @see net.cellcomputing.himawari.library.CqModeBlock#AddContextLightSource(net.cellcomputing.himawari.library.CqLightsource)
	 */
	@Override
    public void AddContextLightSource( final CqLightsource pLS )
    {
        // Add the light to the context stack.
    	//　コンテキストのスタックにライトソースを追加する。
        m_apWorldLights.add( pLS );
    }

    private STLVector<CqLightsource> m_apWorldLights = new STLVector<CqLightsource>( CqLightsource.class );
}
